Index: src/sas/perspectives/fitting/simfitpage.py
===================================================================
--- src/sas/perspectives/fitting/simfitpage.py	(revision acf8e4a58aad50df871a259b771db1d582942abb)
+++ src/sas/perspectives/fitting/simfitpage.py	(revision 662d8d87e9e23b096bab9ae00b2d0677025933d2)
@@ -566,15 +793,9 @@
             self.btAdd.Hide()
         self._store_model()
-        if self.model_cbox_left != None:
-            try:
-                self.model_cbox_left.Clear()
-            except:
-                pass
+        if self.model_cbox_left is not None:
+            self.model_cbox_left.Clear()
             self.model_cbox_left = None
-        if self.model_cbox_right != None:
-            try:
-                self.model_cbox_right.Clear()
-            except:
-                pass
+        if self.model_cbox_right is not None:
+            self.model_cbox_right.Clear()
             self.model_cbox_right = None
         self.constraints_list = []
@@ -584,4 +805,6 @@
         self.sizer_constraints.Layout()
         self.sizer2.Layout()
+        self.Layout
+        self.FitInside()
 
     def _on_select_model(self, event):
@@ -589,25 +812,32 @@
         fill combox box with list of parameters
         """
+        if not self.constraints_list:
+            return
+
+        ##This way PC/MAC both work, instead of using event.GetClientData().
+        model_cbox = self.constraints_list[-1].model_cbox
+        n = model_cbox.GetCurrentSelection()
+        if n == wx.NOT_FOUND:
+            return
+
+        model = model_cbox.GetClientData(n)
         param_list = []
-        ##This way PC/MAC both work, instead of using event.GetClientData().
-        n = self.model_cbox.GetCurrentSelection()
-        model = self.model_cbox.GetClientData(n)
         for id, dic_model in self.constraint_dict.iteritems():
             if model == dic_model:
                 param_list = self.page_finder[id].get_param2fit()
-                #break
-        length = len(self.constraints_list)
-        if length < 1:
-            return
-        param_cbox = self.constraints_list[length - 1][1]
+                break
+
+        param_cbox = self.constraints_list[-1].param_cbox
         param_cbox.Clear()
         ## insert only fittable paramaters
         for param in param_list:
             param_cbox.Append(str(param), model)
-
         param_cbox.Show(True)
-        self.btRemove.Show(True)
+
+        btRemove = self.constraints_list[-1].btRemove
+        btRemove.Show(True)
         self.btAdd.Show(True)
-        self.sizer2.Layout()
+#        self.Layout()
+        self.FitInside()
 
     def _on_select_param(self, event):
@@ -620,12 +850,7 @@
         #param = event.GetString()
 
-        length = len(self.constraints_list)
-        if length < 1:
-            return
-        egal_txt = self.constraints_list[length - 1][2]
-        egal_txt.Show(True)
-
-        ctl2 = self.constraints_list[length - 1][3]
-        ctl2.Show(True)
+        if self.constraints_list:
+            self.constraints_list[-1].egal_txt.Show(True)
+            self.constraints_list[-1].constraint.Show(True)
 
     def _onAdd_constraint(self, event):
@@ -640,125 +865,29 @@
         # before allow to add another constraint
         for item in self.constraints_list:
-            model_cbox = item[0]
-            if model_cbox.GetString(0) == "":
+            if item.model_cbox.GetString(0) == "":
                 msg = " Select a model Name! "
                 wx.PostEvent(self.parent.parent, StatusEvent(status=msg))
                 return
-            param_cbox = item[1]
-            if param_cbox.GetString(0) == "":
+            if item.param_cbox.GetString(0) == "":
                 msg = " Select a parameter Name! "
                 wx.PostEvent(self.parent.parent, StatusEvent(status=msg))
                 return
-            ctl2 = item[3]
-            if ctl2.GetValue().lstrip().rstrip() == "":
-                model = param_cbox.GetClientData(\
-                                            param_cbox.GetCurrentSelection())
+            if item.constraint.GetValue().lstrip().rstrip() == "":
+                model = item.param_cbox.GetClientData(
+                                        item.param_cbox.GetCurrentSelection())
                 if model != None:
                     msg = " Enter a constraint for %s.%s! " % (model.name,
-                                                        param_cbox.GetString(0))
+                                        item.param_cbox.GetString(0))
                 else:
-                     msg = " Enter a constraint"
+                    msg = " Enter a constraint"
                 wx.PostEvent(self.parent.parent, StatusEvent(status=msg))
                 return
         ## some model or parameters can be constrained
         self._show_constraint()
-        self.sizer3.Layout()
-        self.Layout()
-        self.Refresh()
-
-    def _fill_sizer_fit(self):
-        """
-        Draw fit button
-        """
-        self.sizer3.Clear(True)
-        box_description = wx.StaticBox(self, -1, "Fit ")
-        boxsizer1 = wx.StaticBoxSizer(box_description, wx.VERTICAL)
-        sizer_button = wx.BoxSizer(wx.HORIZONTAL)
-
-        self.btFit = wx.Button(self, wx.NewId(), 'Fit', size=wx.DefaultSize)
-        self.btFit.Bind(wx.EVT_BUTTON, self.onFit, id=self.btFit.GetId())
-        self.btFit.SetToolTipString("Perform fit.")
-        if self.batch_on:
-            text = " Fit in Parallel all Data set and model selected.\n"
-        else:
-            text = " This page requires at least one FitPage with a data\n"
-            text = " and a model for fitting."
-        text_hint = wx.StaticText(self, -1, text)
-
-        sizer_button.Add(text_hint, wx.RIGHT | wx.EXPAND, 10)
-        sizer_button.Add(self.btFit, 0, wx.LEFT | wx.ADJUST_MINSIZE, 10)
-
-        boxsizer1.Add(sizer_button, flag=wx.TOP | wx.BOTTOM, border=10)
-        self.sizer3.Add(boxsizer1, 0, wx.EXPAND | wx.ALL, 10)
-        self.sizer3.Layout()
-
-    def _fill_sizer_constraint(self):
-        """
-        Fill sizer containing constraint info
-        """
-        msg = "Select at least 2 model to add constraint "
-        wx.PostEvent(self.parent.parent, StatusEvent(status=msg))
-
-        self.sizer2.Clear(True)
-        if self.batch_on:
-            if self.sizer2.IsShown():
-                self.sizer2.Show(False)
-            return
-        box_description = wx.StaticBox(self, -1, "Fit Constraints")
-        boxsizer1 = wx.StaticBoxSizer(box_description, wx.VERTICAL)
-        sizer_title = wx.BoxSizer(wx.HORIZONTAL)
-        self.sizer_all_constraints = wx.BoxSizer(wx.HORIZONTAL)
-        self.sizer_constraints = wx.BoxSizer(wx.VERTICAL)
-        sizer_button = wx.BoxSizer(wx.HORIZONTAL)
-
-        self.hide_constraint = wx.RadioButton(self, -1, 'No', (10, 10),
-                                              style=wx.RB_GROUP)
-        self.show_constraint = wx.RadioButton(self, -1, 'Yes', (10, 30))
-        self.Bind(wx.EVT_RADIOBUTTON, self._display_constraint,
-                  id=self.hide_constraint.GetId())
-        self.Bind(wx.EVT_RADIOBUTTON, self._display_constraint,
-                  id=self.show_constraint.GetId())
-        if self.batch_on:
-            self.hide_constraint.Enable(False)
-            self.show_constraint.Enable(False)
-        self.hide_constraint.SetValue(True)
-        self.show_constraint.SetValue(False)
-
-        sizer_title.Add(wx.StaticText(self, -1, " Model"))
-        sizer_title.Add((10, 10))
-        sizer_title.Add(wx.StaticText(self, -1, " Parameter"))
-        sizer_title.Add((10, 10))
-        sizer_title.Add(wx.StaticText(self, -1, " Add Constraint?"))
-        sizer_title.Add((10, 10))
-        sizer_title.Add(self.show_constraint)
-        sizer_title.Add(self.hide_constraint)
-        sizer_title.Add((10, 10))
-
-        self.btAdd = wx.Button(self, wx.NewId(), 'Add')
-        self.btAdd.Bind(wx.EVT_BUTTON, self._onAdd_constraint,
-                        id=self.btAdd.GetId())
-        self.btAdd.SetToolTipString("Add another constraint?")
-        self.btAdd.Hide()
-
-        text_hint = wx.StaticText(self, -1,
-                                  "Example: [M0][paramter] = M1.parameter")
-        sizer_button.Add(text_hint, 0 , wx.LEFT | wx.EXPAND | wx.ADJUST_MINSIZE, 10)
-        sizer_button.Add(self.btAdd, 0, wx.LEFT | wx.EXPAND | wx.ADJUST_MINSIZE, 10)
-
-        boxsizer1.Add(sizer_title, flag=wx.TOP | wx.BOTTOM, border=10)
-        boxsizer1.Add(self.sizer_all_constraints, flag=wx.TOP | wx.BOTTOM,
-                      border=10)
-        boxsizer1.Add(self.sizer_constraints, flag=wx.TOP | wx.BOTTOM,
-                      border=10)
-        boxsizer1.Add(sizer_button, flag=wx.TOP | wx.BOTTOM, border=10)
-
-        self.sizer2.Add(boxsizer1, 0, wx.EXPAND | wx.ALL, 10)
-        self.sizer2.Layout()
-
-        #self.SetScrollbars(20,20,25,65)
+        self.FitInside()
 
     def _set_constraint(self):
         """
-        get values from the constrainst textcrtl ,parses them into model name
+        get values from the constraint textcrtl ,parses them into model name
         parameter name and parameters values.
         store them in a list self.params .when when params is not empty
@@ -767,13 +896,13 @@
         """
         for item in self.constraints_list:
-            select0 = item[0].GetSelection()
+            select0 = item.model_cbox.GetSelection()
             if select0 == wx.NOT_FOUND:
                 continue
-            model = item[0].GetClientData(select0)
-            select1 = item[1].GetSelection()
+            model = item.model_cbox.GetClientData(select0)
+            select1 = item.param_cbox.GetSelection()
             if select1 == wx.NOT_FOUND:
                 continue
-            param = item[1].GetString(select1)
-            constraint = item[3].GetValue().lstrip().rstrip()
+            param = item.param_cbox.GetString(select1)
+            constraint = item.constraint.GetValue().lstrip().rstrip()
             if param.lstrip().rstrip() == "":
                 param = None
@@ -808,108 +937,7 @@
                         # wrap in param/constraint in str() to remove unicode
                         self.page_finder[id].set_model_param(str(param),
-                                                        str(constraint), fid=fid)
+                                str(constraint), fid=fid)
                     break
         return True
-
-    def _fill_sizer_model_list(self, sizer):
-        """
-        Receive a dictionary containing information to display model name
-        """
-        ix = 0
-        iy = 0
-        list = []
-        sizer.Clear(True)
-
-        new_name = wx.StaticText(self, -1, '  Model Title ',
-                                 style=wx.ALIGN_CENTER)
-        new_name.SetBackgroundColour('orange')
-        new_name.SetForegroundColour(wx.WHITE)
-        sizer.Add(new_name, (iy, ix), (1, 1),
-                            wx.LEFT | wx.EXPAND | wx.ADJUST_MINSIZE, 15)
-        ix += 2
-        model_type = wx.StaticText(self, -1, '  Model ')
-        model_type.SetBackgroundColour('grey')
-        model_type.SetForegroundColour(wx.WHITE)
-        sizer.Add(model_type, (iy, ix), (1, 1),
-                            wx.EXPAND | wx.ADJUST_MINSIZE, 0)
-        ix += 1
-        data_used = wx.StaticText(self, -1, '  Data ')
-        data_used.SetBackgroundColour('grey')
-        data_used.SetForegroundColour(wx.WHITE)
-        sizer.Add(data_used, (iy, ix), (1, 1),
-                            wx.EXPAND | wx.ADJUST_MINSIZE, 0)
-        ix += 1
-        tab_used = wx.StaticText(self, -1, '  FitPage ')
-        tab_used.SetBackgroundColour('grey')
-        tab_used.SetForegroundColour(wx.WHITE)
-        sizer.Add(tab_used, (iy, ix), (1, 1),
-                            wx.EXPAND | wx.ADJUST_MINSIZE, 0)
-        for id, value in self.page_finder.iteritems():
-            if id not in self.parent.opened_pages:
-                continue
-
-            if self.batch_on != self.parent.get_page_by_id(id).batch_on:
-                continue
-
-            data_list = []
-            model_list = []
-            # get data name and model objetta
-            for fitproblem in value.get_fit_problem():
-
-                data = fitproblem.get_fit_data()
-                if not data.is_data:
-                    continue
-                name = '-'
-                if data is not None and data.is_data:
-                    name = str(data.name)
-                data_list.append(name)
-
-                model = fitproblem.get_model()
-                if model is None:
-                    continue
-                model_list.append(model)
-
-            if len(model_list) == 0:
-                continue
-            # Draw sizer
-            ix = 0
-            iy += 1
-            model = model_list[0]
-            name = '_'
-            if model is not None:
-                name = str(model.name)
-            cb = wx.CheckBox(self, -1, name)
-            cb.SetValue(False)
-            cb.Enable(model is not None and data.is_data)
-            sizer.Add(cb, (iy, ix), (1, 1),
-                       wx.LEFT | wx.EXPAND | wx.ADJUST_MINSIZE, 15)
-            wx.EVT_CHECKBOX(self, cb.GetId(), self.check_model_name)
-            ix += 2
-            type = model.__class__.__name__
-            model_type = wx.StaticText(self, -1, str(type))
-            sizer.Add(model_type, (iy, ix), (1, 1),
-                      wx.EXPAND | wx.ADJUST_MINSIZE, 0)
-            if self.batch_on:
-                data_used = wx.ComboBox(self, -1, style=wx.CB_READONLY)
-                data_used.AppendItems(data_list)
-                data_used.SetSelection(0)
-            else:
-                data_used = wx.StaticText(self, -1, data_list[0])
-
-            ix += 1
-            sizer.Add(data_used, (iy, ix), (1, 1),
-                      wx.EXPAND | wx.ADJUST_MINSIZE, 0)
-            ix += 1
-            caption = value.get_fit_tab_caption()
-            tab_caption_used = wx.StaticText(self, -1, str(caption))
-            sizer.Add(tab_caption_used, (iy, ix), (1, 1),
-                      wx.EXPAND | wx.ADJUST_MINSIZE, 0)
-
-            self.model_list.append([cb, value, id, model])
-
-        iy += 1
-        sizer.Add((20, 20), (iy, ix), (1, 1),
-                  wx.LEFT | wx.EXPAND | wx.ADJUST_MINSIZE, 15)
-        sizer.Layout()
 
     def on_set_focus(self, event=None):
@@ -921,2 +949,11 @@
                 wx.PostEvent(self.parent.parent, PanelOnFocusEvent(panel=self))
             self.page_finder = self.parent._manager.get_page_finder()
+
+
+def setComboBoxItems(cbox, items):
+    assert isinstance(cbox, wx.ComboBox)
+    selected = cbox.GetStringSelection()
+    cbox.Clear()
+    for k, (name, value) in enumerate(items):
+        cbox.Append(name, value)
+    cbox.SetStringSelection(selected)
Index: src/sas/plottools/toolbar.py
===================================================================
--- src/sas/plottools/toolbar.py	(revision d3d67f06423dc337fd087c81b7cbd502dc7e1084)
+++ src/sas/plottools/toolbar.py	(revision 2d88fc4a6cc278c2ea7ac05c75e83d324432f287)
@@ -19,4 +19,13 @@
 
 class NavigationToolBar(NavigationToolbar2WxAgg):
+    _NTB2_HOME = wx.NewId()
+    _NTB2_BACK = wx.NewId()
+    _NTB2_FORWARD = wx.NewId()
+    _NTB2_PAN = wx.NewId()
+    _NTB2_ZOOM = wx.NewId()
+    _NTB2_SAVE = wx.NewId()
+    _NTB2_PRINT = wx.NewId()
+    _NTB2_RESET = wx.NewId()
+    _NTB2_COPY = wx.NewId()
     """
     Overwrite matplotlib toolbar
@@ -31,12 +40,4 @@
     def _init_toolbar(self):
         self._parent = self.canvas.GetParent()
-        self._NTB2_HOME = wx.NewId()
-        self._NTB2_BACK = wx.NewId()
-        self._NTB2_FORWARD = wx.NewId()
-        self._NTB2_PAN = wx.NewId()
-        self._NTB2_ZOOM = wx.NewId()
-        self._NTB2_SAVE = wx.NewId()
-        self._NTB2_PRINT = wx.NewId()
-        self._NTB2_RESET = wx.NewId()
 
         # for mpl 1.2+ compatibility
@@ -101,16 +102,13 @@
         """
         # Slicer plot popup menu
-        wx_id = wx.NewId()
         popup = wx.Menu()
-        popup.Append(wx_id, '&Save image', 'Save image as PNG')
-        wx.EVT_MENU(self, wx_id, self.save_figure)
+        popup.Append(self._NTB2_SAVE, '&Save image', 'Save image as PNG')
+        wx.EVT_MENU(self, self._NTB2_SAVE, self.save_figure)
 
-        wx_id = wx.NewId()
-        popup.Append(wx_id, '&Print image', 'Print image ')
-        wx.EVT_MENU(self, wx_id, self.print_figure)
+        popup.Append(self._NTB2_PRINT, '&Print image', 'Print image ')
+        wx.EVT_MENU(self, self._NTB2_PRINT, self.print_figure)
 
-        wx_id = wx.NewId()
-        popup.Append(wx_id, '&Copy to Clipboard', 'Copy image to the clipboard')
-        wx.EVT_MENU(self, wx_id, self.copy_figure)
+        popup.Append(self._NTB2_COPY, '&Copy to Clipboard', 'Copy image to the clipboard')
+        wx.EVT_MENU(self, self._NTB2_COPY, self.copy_figure)
 
         # Show the popup menu relative to the location of the toolbar
Index: test/sasfit/test/utest_fit_line.py
===================================================================
--- test/sasfit/test/utest_fit_line.py	(revision acf8e4a58aad50df871a259b771db1d582942abb)
+++ test/sasfit/test/utest_fit_line.py	(revision bc87305316c560a93eeaf77db05eb6721733d636)
@@ -11,4 +11,19 @@
 from sas.models.LineModel import LineModel
 from sas.models.Constant import Constant
+
+from bumps import fitters
+try:
+    from bumps.options import FIT_CONFIG
+    def set_fitter(alg, opts):
+        FIT_CONFIG.selected_id = alg
+        FIT_CONFIG.values[alg].update(opts, monitors=[])
+except:
+    # CRUFT: Bumps changed its handling of fit options around 0.7.5.6
+    def set_fitter(alg, opts):
+        #print "fitting",alg,opts
+        #print "options",fitters.FIT_OPTIONS[alg].__dict__
+        fitters.FIT_DEFAULT = alg
+        fitters.FIT_OPTIONS[alg].options.update(opts, monitors=[])
+
 
 class testFitModule(unittest.TestCase):
@@ -67,11 +82,5 @@
 
     def fit_bumps(self, alg, **opts):
-        #Importing the Fit module
-        from bumps import fitters
-        fitters.FIT_DEFAULT = alg
-        fitters.FIT_OPTIONS[alg].options.update(opts)
-        fitters.FIT_OPTIONS[alg].options.update(monitors=[])
-        #print "fitting",alg,opts
-        #kprint "options",fitters.FIT_OPTIONS[alg].__dict__
+        set_fitter(alg, opts)
         self.fit_single(isdream=(alg=='dream'))
 
Index: test/sasfit/test/utest_fit_smeared.py
===================================================================
--- test/sasfit/test/utest_fit_smeared.py	(revision acf8e4a58aad50df871a259b771db1d582942abb)
+++ test/sasfit/test/utest_fit_smeared.py	(revision bc87305316c560a93eeaf77db05eb6721733d636)
@@ -13,4 +13,20 @@
 from sas.models.CylinderModel import CylinderModel
 from sas.models.SphereModel import SphereModel
+
+
+from bumps import fitters
+try:
+    from bumps.options import FIT_CONFIG
+    def set_fitter(alg, opts):
+        FIT_CONFIG.selected_id= alg
+        FIT_CONFIG.values[alg].update(opts, monitors=[])
+except:
+    # CRUFT: Bumps changed its handling of fit options around 0.7.5.6
+    def set_fitter(alg, opts):
+        #print "fitting",alg,opts
+        #print "options",fitters.FIT_OPTIONS[alg].__dict__
+        fitters.FIT_DEFAULT = alg
+        fitters.FIT_OPTIONS[alg].options.update(opts, monitors=[])
+
 
 class testFitModule(unittest.TestCase):
@@ -57,9 +73,5 @@
             Cylinder fit with dispersion
         """
-        alg = 'lm'
-        from bumps import fitters
-        fitters.FIT_DEFAULT = alg
-        #fitters.FIT_OPTIONS[alg].options.update(opts)
-        fitters.FIT_OPTIONS[alg].options.update(monitors=[])
+        set_fitter('lm', {})
         self._dispersion(fitter = Fit())
 
